//(c) 2019 Vanillatech GmbH (https://labs.vanilaltech.de)

#property copyright   "2019 Vanillatech GmbH"
#property link        "https://labs.vanillatech.de"

#include <mql4-http.mqh>

input string tokenid = "[unique model id]";

input double TakeProfit = 10000;
input double Threshold = 0;
input double StopLoss = 10000;
input double Lots          = 0.01;

double feature0[],feature1[],feature2[],feature3[];


int macds;
int macds2;
int aisignal = 0;
string lastOrderWas = "";
input bool Learnmode = true;

int OnInit() {
ArraySetAsSeries(feature0,true);
ArraySetAsSeries(feature1,true);
return 0;
}


void OnTick(void)
  {
   static datetime Time0;
   if (Time0 == Time[0]) return; Time0 = Time[0];
   ArraySetAsSeries(feature0,false);
   ArrayResize(feature0,Bars);
   ArraySetAsSeries(feature0,true);
   ArraySetAsSeries(feature1,false);
   ArrayResize(feature1,Bars);
   ArraySetAsSeries(feature1,true);

   
   int    cnt,ticket,total;
   int signal = 9;
   double sl = TakeProfit;
   double TrailingStop  = StopLoss;

   if(Bars<100)
     {
      Print("bars < 100");
      return;
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return;
     }


   int candles = 7;
   
   feature0[0] = MathRound((iOpen(NULL,0,0)-iOpen(NULL,0,candles))*100);
   feature1[0] = MathRound((iMACD(NULL,0,12,26,9,PRICE_OPEN,MODE_MAIN,0))*10);

   
   
   string cookie=NULL,headers;
   char post[];
   string result;
   int res[30];
   int k = 0;

   string url= "https://ml.vanillatech.de/v2/api.php?query={\"token\":\"" + tokenid + "\",\"activateNewNeurons\":true,\"activationThreshold\":0.52,\"learnmode\":";
      
   
   if (Learnmode && Bars < 10000) {

      url += "true,\"outputLMT\":0,";
  
      url += "\"inputFeature\":['" + feature0[0]+ "'],\"featureMatrix\":['" + feature1[candles]+ "']}";
      result = httpGET(url);
   } else {
      url += "false,\"outputLMT\":";
      int n = 0;
      for (n = 10;n>=0;n--){

      result = httpGET(url + "0,\"featureMatrix\":['" + feature1[n]+ "']}");
      }
      result = httpGET(url + "20}");
   }
  
  
   if(result == "")
     {
      Print("Error in WebRequest. Error code  =",GetLastError());
     }
   else
     {
      //--- Load successfully
      
      string outp[];
      
      result = StringSubstr(result,11,StringLen(result)-1);
      //Print("result: " + result);
      k = StringSplit(result,StringGetCharacter(",",0),outp);
      
      for (int c=0;c<k;c++) {
         res[c] = StrToInteger(StringSubstr(outp[c],1,-1));
      }
      Print("Feature1: " + feature1[2] + " - " + feature1[1] + " - " + feature1[0] + " AI prediction: " + res[0] );
     }
   
   aisignal = res[0];

   total=OrdersTotal();
   double l = Lots;
   int e = 20;

   if(total<1)
     {
      
      
      //--- no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ",AccountFreeMargin());
         return;
        }
        
      
        
        
      //--- check for long position (BUY) possibility
      
      

        if (aisignal > Threshold)
        {
        
         ticket=OrderSend(Symbol(),OP_BUY,l,Ask,3,Bid-TrailingStop*Point,Ask+sl*Point,"ML signal",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("BUY order opened : ",OrderOpenPrice());
           }
         else
            Print("Error opening BUY order : ",GetLastError());
         return;
        }
        
        
      //--- check for short position (SELL) possibility
     
      
        if (aisignal < -Threshold)
        {
        
         ticket=OrderSend(Symbol(),OP_SELL,l,Bid,3,Ask+TrailingStop*Point,Bid-sl*Point,"ML signal",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("SELL order opened : ",OrderOpenPrice());
           }
         else
            Print("Error opening SELL order : ",GetLastError());
        
      //--- exit from the "no opened orders" block
      return;
      }
      
   }

//--- it is important to enter the market correctly, but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         //--- long position is opened
         if(OrderType()==OP_BUY)
           {
            //--- should it be closed?
            //if (OrderOpenTime() <= Time[candles]) //
            if (aisignal < 0)
            {

               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet))
                  Print("OrderClose error ",GetLastError());
               return;
              }
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           //}
           }
         else // go to short position
           {
            //if (OrderOpenTime() <= Time[candles]) //
            if (aisignal > 0)
            {

               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet))
                  Print("OrderClose error ",GetLastError());
               return;
              }}
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           
           
           }
       // }
     }
//---
  
  }
//+------------------------------------------------------------------+
